"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Pedigree(ProtocolElement):
    """
    This is the concept of a family with associated phenotypes as present
    in the record RDParticipant
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "gelFamilyId",
        "participants",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "analysisPanels": reports_2_1_0.AnalysisPanel,
            "participants": reports_2_1_0.RDParticipant,
            "versionControl": reports_2_1_0.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "Gel_BioInf_Models.AnalysisPanel": reports_2_1_0.AnalysisPanel,
            "Gel_BioInf_Models.RDParticipant": reports_2_1_0.RDParticipant,
            "Gel_BioInf_Models.VersionControl": reports_2_1_0.VersionControl,
            "Gel_BioInf_Models.Pedigree": reports_2_1_0.Pedigree,
        }

    __slots__ = [
        "gelFamilyId",
        "participants",
        "versionControl",
        "analysisPanels",
    ]

    def __init__(
        self,
        gelFamilyId,
        participants,
        versionControl,
        analysisPanels=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_2_1_0.Pedigree model.

        :param gelFamilyId:
            Family id which internally translate to a sample set
        :type gelFamilyId: str
        :param participants:
        :type participants: list[RDParticipant]
        :param versionControl:
            Model version number
        :type versionControl: VersionControl
        :param analysisPanels:
        :type analysisPanels: None | list[AnalysisPanel]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.1.0"
